#include "StdAfx.h"
#include ".\mainframe.h"
#include "resource.h"
#include "AboutBox.h"
#include <CommCtrl.h>
#include <StdIO.h>

CMainFrame::CMainFrame(HINSTANCE hInst)
{
	p_hInst=hInst;
	hWndMain=NULL;
	szAllowed=NULL;
	szBlocked=NULL;
	iOfficeVersion=0;
}

CMainFrame::~CMainFrame(void)
{
	if (szAllowed!=NULL)
		delete[] szAllowed;
	if (szBlocked!=NULL)
		delete[] szBlocked;
}

HWND CMainFrame::Initialize()
{
	CreationState=true;
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 
	wcex.style			= CS_HREDRAW|CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)stWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= p_hInst;
	wcex.hIcon			= LoadIcon(p_hInst,(LPCTSTR)IDI_MAINICON);
	wcex.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_BTNFACE+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "OulookUnlock_Wnd_Class";
	wcex.hIconSm		= LoadIcon(p_hInst,(LPCTSTR)IDI_MAINICON);

	if (!RegisterClassEx(&wcex)) return NULL;

	hWndMain=CreateWindow("OulookUnlock_Wnd_Class","Outlook Unlocker",
		WS_VISIBLE|WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,//|WS_THICKFRAME,
		CW_USEDEFAULT,CW_USEDEFAULT,370,300,HWND_DESKTOP,NULL,p_hInst,this);
	// Rcupration de la police systme pour appliquer sur les contrles enfants
	HFONT hSysFnt=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
	// Cration des contrles enfants de la fentre
	hGrpBox1=CreateWindow("BUTTON","Autorisations : ",WS_CHILD|BS_GROUPBOX|WS_VISIBLE,5,5,100,100,hWndMain,NULL,p_hInst,0);
	SendMessage(hGrpBox1,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	hLblAll=CreateWindow("Static",
		"Par dfaut, Outlook bloque l'accs aux pices jointes portant les extensions "
		"ci-dessous. Cochez les cases correspondantes pour les autoriser .",
		WS_CHILD|WS_VISIBLE,5,10,100,100,hWndMain,NULL,p_hInst,0);
	SendMessage(hLblAll,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	// Attention : Les valeurs ci-dessous doivent tre en minuscules
	char *szDefExt[KNOWN_EXTENSIONS_COUNT]={".bat",".cmd",".com",".exe",".hlp",".inf",".js",".lnk",".msi",".pif",".reg",".scr",".url",".vbs"};
	int i;
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
	{
		szKnownExt[i]=szDefExt[i];
		hChkAllow[i]=CreateWindow("BUTTON",szDefExt[i],BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE,
			20+i*3,30+i*2,75,22,hWndMain,(HMENU)(IDC_CHK_KNOWNEXT01+i),p_hInst,0);
		SendMessage(hChkAllow[i],WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	}
	hGrpBox2=CreateWindow("BUTTON",
		"Bloquages supplmentaires : ",
		WS_CHILD|BS_GROUPBOX|WS_VISIBLE,5,5,100,100,hWndMain,NULL,p_hInst,0);
	SendMessage(hGrpBox2,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	hLblBlk=CreateWindow("Static",
		"Bloquer l'accs aux pices jointes portant les extensions suivantes : "
		"(Sparez les diffrentes valeurs par un point virgule.)",WS_CHILD|WS_VISIBLE,5,10,100,100,hWndMain,NULL,p_hInst,0);
	SendMessage(hLblBlk,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	hTxtBlk=CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT","",
		WS_CHILD|WS_VISIBLE|ES_AUTOHSCROLL,5,15,100,100,hWndMain,(HMENU)IDC_TXT_NEWEXT,p_hInst,0);
	SendMessage(hTxtBlk,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));

	hStatBar=CreateStatusWindow(WS_CHILD|WS_VISIBLE,"Bienvenue ...",hWndMain,IDC_STATBAR);
	hBtnApply=CreateWindow("BUTTON","Appliquer",WS_CHILD|WS_VISIBLE,5,20,50,20,hWndMain,(HMENU)IDC_BTN_APPLY,p_hInst,0);
	SendMessage(hBtnApply,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	hBtnExit=CreateWindow("BUTTON","Fermer",WS_CHILD|WS_VISIBLE,5,25,50,20,hWndMain,(HMENU)IDC_BTN_EXIT,p_hInst,0);
	EnableWindow(hBtnApply,FALSE);
	SendMessage(hBtnExit,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));
	hBtnAbout=CreateWindow("BUTTON","A propos de ...",WS_CHILD|WS_VISIBLE,5,30,50,20,hWndMain,(HMENU)IDC_BTN_ABOUT,p_hInst,0);
	SendMessage(hBtnAbout,WM_SETFONT,(WPARAM)hSysFnt,MAKELPARAM(TRUE,0));

	// Appel de la fonction OnSize pour mettre les contrles  leur place
	RECT rcClient;
	GetClientRect(hWndMain,&rcClient);
	OnSize(SIZE_RESTORED,rcClient.right,rcClient.bottom);
	// Rcupration des rglages courants
	GetCurrentSettings();
	// Mise  jour des contrles
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
		SendMessage(hChkAllow[i],BM_SETCHECK,(WPARAM)((bOldState[i]==true)?BST_CHECKED:BST_UNCHECKED),0);
	if (szBlocked!=NULL)
		SetWindowText(hTxtBlk,szBlocked);
	// Affichage d'un message si aucune version d'Outlook n'a t trouve
	char szMsg[1024];
	if (iOfficeVersion==0)
	{
		MessageBox(hWndMain,"Aucune version suffisament rcente d'Outlook n'a t trouve.\n"
			"Aucun changement ne sera effectu dans la base de registre.","Outlook Unlocker",MB_ICONEXCLAMATION);
	} else {
		sprintf(szMsg,"Les rglages seront effectue pour la version %0.1f d'Outlook.",(float)iOfficeVersion);
		MessageBox(hWndMain,szMsg,"Outlook Unlocker",MB_ICONINFORMATION);
	}

	CreationState=false;
	return hWndMain;
}

LRESULT CALLBACK CMainFrame::WindowProcedure(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_DESTROY:
			PostQuitMessage(0);
			return FALSE;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_BTN_APPLY:
					OnApplyChanges();
					break;
				case IDC_BTN_EXIT:
					DestroyWindow(hWnd);
					break;
				case IDC_BTN_ABOUT:
					ShowAboutBox();
					break;
				case IDC_TXT_NEWEXT:
					// Traitement spcial pour la textbox
					switch(HIWORD(wParam))
					{
						case EN_SETFOCUS:
							SendMessage(hTxtBlk,EM_SETSEL,(WPARAM)(int)1,(LPARAM)GetWindowTextLength(hTxtBlk));
							break;
						case EN_CHANGE:
							OnSomethingAsChanged(IDC_TXT_NEWEXT);
							break;
					}
					break;
				default:
					OnSomethingAsChanged(LOWORD(wParam));
					break;
			}
			break;
		case WM_SIZE:
			OnSize((int)wParam,LOWORD(lParam),HIWORD(lParam));
			break;
		default:
			return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
	return FALSE;
}

void CMainFrame::OnSomethingAsChanged(int iCtrlID)
{
	// Si on est en mode cration, alors, ne pas activer le bouton "Appliquer"
	if (CreationState) return;
	// Si On n'a pas trouv de version correcte d'Outlook, idem
	if (iOfficeVersion==0) return;
	EnableWindow(hBtnApply,TRUE);
}

void CMainFrame::GetCurrentSettings()
{
	// Recherche de la plus rcente version d'Outlook installe
	// On commence par rechercher la version de Ms Office (11, puis 10, puis 9)
	int i;
	char szKey[512];
	HKEY hKeyVersion,hKeyOutlook,hKeySecurity;
	long lRes;
	DWORD dwSize;
	iOfficeVersion=0;
	for (i=11;i>8;i--)
	{
		sprintf(szKey,"Software\\Microsoft\\Office\\%0.1f",(float)i);
		lRes=RegOpenKeyEx(HKEY_CURRENT_USER,szKey,0,KEY_READ,&hKeyVersion);
		if (lRes==ERROR_SUCCESS)
		{
			iOfficeVersion=i;
			break;
		}
	}
	// Si le numro de version est toujours  zro, alors il n'y a pas
	// de version suffisament rcente de Ms Office installe
	if (iOfficeVersion==0) return;
	// On vrifie si la sous-clef "Outlook" existe
	lRes=RegOpenKeyEx(hKeyVersion,"Outlook",0,KEY_READ,&hKeyOutlook);
	if (lRes!=ERROR_SUCCESS)
	{
		// On ferme la clef ouverte prcdement
		RegCloseKey(hKeyVersion);
		// On remet la version d'Office  zro
		iOfficeVersion=0;
		return;
	}
	// On vrifie si la sous-clef "Security" existe
	lRes=RegOpenKeyEx(hKeyOutlook,"Security",0,KEY_READ,&hKeySecurity);
	if (lRes!=ERROR_SUCCESS)
	{
		// On ferme les clefs ouvertes prcdement
		RegCloseKey(hKeyVersion);
		RegCloseKey(hKeyOutlook);
		// On remet la version d'Office  zro
		iOfficeVersion=0;
		return;
	}
	// Quelle taille faut-il allouer pour la premire valeur ?
	lRes=RegQueryValueEx(hKeySecurity,"Level1Remove",NULL,NULL,NULL,&dwSize);
	// Si la valeur existe et qu'elle n'est pas vide, alors, on la rcupre
	if ((lRes==ERROR_SUCCESS)&&(dwSize>0))
	{
		if (szAllowed!=NULL) delete[] szAllowed;
		szAllowed=new char[dwSize+5];
		RegQueryValueEx(hKeySecurity,"Level1Remove",NULL,NULL,(LPBYTE)szAllowed,&dwSize);
		// Vrifier les extensions connues
		ParseKnownExtensions(szAllowed);
		// Mettre  jour les variables concernes
		for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++) bOldState[i]=bTmpState[i];
	}
	// On rpte la mme opration avec la deuxime valeur
	lRes=RegQueryValueEx(hKeySecurity,"Level1Add",NULL,NULL,NULL,&dwSize);
	if ((lRes==ERROR_SUCCESS)&&(dwSize>0))
	{
		if (szBlocked!=NULL) delete[] szAllowed;
		szBlocked=new char[dwSize+5];
		RegQueryValueEx(hKeySecurity,"Level1Add",NULL,NULL,(LPBYTE)szBlocked,&dwSize);
	}

	// Refermer les clefs de registre ouvertes prcdement
	RegCloseKey(hKeySecurity);
	RegCloseKey(hKeyOutlook);
	RegCloseKey(hKeyVersion);
}

void CMainFrame::ParseKnownExtensions(char *szStr)
{
	// Lecture d'une chaine de caractre pour vrifier si elle contient une ou plusieurs
	// des extensions gnralement bloques par Outlook
	int i,j;
	char *szLower,*Pos,c;
	// Initialisation des variables temporaires
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++) bTmpState[i]=false;
	i=strlen(szStr);
	// Si la chaine est vide, alors on sort
	if (i==0) return;
	// On fait une copie de la chane pour la mettre en minuscules
	szLower=new char[i+1];
	strcpy(szLower,szStr);
	_strlwr(szLower);
	// On vrifie l'ventuelle prsence de chaque extension connue
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
	{
		Pos=strstr(szLower,szKnownExt[i]);
		if (Pos!=NULL) // vrifier que notre extension n'est pas un sous-string d'une autre
		{
			j=strlen(szKnownExt[i]);
			c=*(Pos+j);
			if ((c=='\0')||(c==';')||(c==' ')) bTmpState[i]=true;
		}
	}
	delete[] szLower;
}

void CMainFrame::OnApplyChanges()
{
	bool bNewState;
	char *szStr;
	int i,j=0;
	// Calcul de la taille maxi qu'aura notre chane de caractres pour
	// l'autorisation des extensions bloques par dfaut
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
	{
		j+=strlen(szKnownExt[i]);
		j++;
	}
	szStr=new char[j];
	szStr[0]='\0';
	// On vrifie pour chaque extension connue s'il faut l'autoriser ou non
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
	{
		bNewState=(SendMessage(hChkAllow[i],BM_GETCHECK,0,0)==BST_CHECKED);
		// S'il faut l'autoriser, on l'ajoute  notre chane de caractres
		if (bNewState)
		{
			if (strlen(szStr)>0) strcat(szStr,";");
			strcat(szStr,szKnownExt[i]);
		}
	}
	HKEY hKey;
	char szKey[512];
	long lRes1,lRes2;
	sprintf(szKey,"Software\\Microsoft\\Office\\%0.1f\\Outlook\\Security",(float)iOfficeVersion);
	// On essaye d'ouvrir la clef contenant la valeur  modifier/crer
	lRes1=RegOpenKeyEx(HKEY_CURRENT_USER,szKey,0,KEY_SET_VALUE,&hKey);
	if (lRes1!=ERROR_SUCCESS)
	{
		MessageBox(hWndMain,"Impossible d'accder au registre de Windows !\n"
			"Les changements ne seront pas effectus.","Erreur",MB_ICONEXCLAMATION);
		delete []szStr;
		return;
	}
	j=strlen(szStr);
	lRes1=RegSetValueEx(hKey,"Level1Remove",0,REG_SZ,(BYTE*)szStr,j);
	delete []szStr;
	// On traite les extensions  bloquer
	i=GetWindowTextLength(hTxtBlk);
	if (i>0)
	{
		szStr=new char[i+5];
		GetWindowText(hTxtBlk,szStr,i+5);
		lRes2=RegSetValueEx(hKey,"Level1Add",0,REG_SZ,(BYTE*)szStr,i);
	} else {
		lRes2=RegSetValueEx(hKey,"Level1Add",0,REG_SZ,(BYTE*)"",0);
	}
	RegCloseKey(hKey);
	if ((lRes1!=ERROR_SUCCESS)||(lRes2!=ERROR_SUCCESS))
	{
		MessageBox(hWndMain,"Erreur lors de l'criture dans le registre de Windows !\n"
			"Les changements ne seront pas tous effectus.\n"
			"Relancez le logiciel pour vrifier.","Erreur",MB_ICONEXCLAMATION);
		return;
	}
	MessageBox(hWndMain,"Les modifications ont t apportes au registre de Windows.\n"
		"Elle prendront effet au prochain (re)dmarrage d'Outlook.",
		"Rglages appliqus",MB_ICONINFORMATION);
	EnableWindow(hBtnApply,FALSE);
}

LRESULT CALLBACK CMainFrame::stWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	CMainFrame *pThis=NULL;
	if (uMsg==WM_CREATE)
	{
		pThis=(CMainFrame*)((LPCREATESTRUCT(lParam))->lpCreateParams);
		SetWindowLong(hWnd,GWL_USERDATA,(long)pThis);
	} else {
		pThis=(CMainFrame*)GetWindowLong(hWnd,GWL_USERDATA);
	}
	return pThis->WindowProcedure(hWnd,uMsg,wParam,lParam);
}

BOOL CMainFrame::Show(int CmdShow)
{
	return ShowWindow(hWndMain,CmdShow);
}

void CMainFrame::ShowAboutBox()
{
	CAboutBox dlg(hWndMain);
	dlg.ShowModal();
}

void CMainFrame::OnSize(int SizeType,int ClientWdth,int ClientHght)
{
	if (SizeType==SIZE_MINIMIZED) return;
	int i,x,y,dx,dy;
	//
	SendMessage(hStatBar,WM_SIZE,(WPARAM)SizeType,MAKELPARAM(ClientWdth,ClientHght));
	MoveWindow(hGrpBox1,10,5,ClientWdth-20,(ClientHght/3)+20,TRUE);
	MoveWindow(hLblAll,20,20,ClientWdth-40,45,TRUE);
	dx=(ClientWdth-65)/7;
	dy=((ClientHght/3)-60)/2;
	for (i=0;i<KNOWN_EXTENSIONS_COUNT;i++)
	{
		x=20+(i%7)*(dx+5);
		y=60+(i/7)*(dy+10);
		MoveWindow(hChkAllow[i],x,y,dx,20,TRUE);
	}
	MoveWindow(hGrpBox2,10,ClientHght/3+30,ClientWdth-20,ClientHght/3+5,TRUE);
	MoveWindow(hLblBlk,20,ClientHght/3+50,ClientWdth-40,30,TRUE);
	MoveWindow(hTxtBlk,20,ClientHght/3+85,ClientWdth-40,20,TRUE);
	dx=(ClientWdth-40)/3;
	MoveWindow(hBtnApply,10,2*(ClientHght/3)+40,dx,22,TRUE);
	MoveWindow(hBtnExit,dx+20,2*(ClientHght/3)+40,dx,22,TRUE);
	MoveWindow(hBtnAbout,dx+dx+30,2*(ClientHght/3)+40,dx,22,TRUE);
}
